---
layout: default
title: Contributing
---

<h1>Contributing code to a deliberist project!</h1>

<p>
    Contributing to any of the deliberist projects is easy, and <b>always</b>
    welcome!  The best way to contribute changes to any deliberist project is to
    fork the GitLab repository, make the changes local to your forked
    repository, then submit a Merge Request through GitLab.  I am not too
    concerned with requiring the use of separate (non-default) branches since
    the preferred method of contributions is to fork the repository.  Separate
    branches are welcome, but not strictly required.
</p>

<p>
    Although there are no formal coding standards used with most of the
    projects, your Merge Request is more likely to be successful if your changes
    are consistent with existing coding styles. This includes indentations,
    variable/method names, and even the amount of comments and documentation.
    That said, some projects use standard linting tools, like pylint for Python
    or rubocop for Ruby, to enforce code consistency.
</p>

<p>
    If a project contains manpages, ensure the documentation is still accurate.
    For a quick groff syntax reference, see the <code>groff_man(7)</code>
    manpage.
</p>

<p>
    Merge Requests are more likely to be successful if the commits also include
    new unit tests to ensure the new or fixed functionality actually works.
    Though there are some select situations where more tests will not be
    necessary. This will be determined on a case-by-case basis.
</p>

<p>
    When in doubt, create unit tests, add code comments, ensure CI jobs complete
    successfully, and add as much information as you can to the Merge Request.
    The main developer will respond as soon as possible.
</p>

<h1>Contributing financially to a deliberist project.</h1>

<p>
    With all that said, there are ways to contribute financially to a deliberist
    project.  First and foremost, any contributions do not go to the developer
    directly.  All monetary contributions are directly routed to a
    <a href="https://www.savingforcollege.com/intro-to-529s/what-is-a-529-plan">529 Plan</a>
    account, and ultimately benefit my children.
</p>

<p>
    There is absolutely no pressure to contribute in this way.  If you decide
    donating money is the route you desire then there are multiple ways to
    accomplish this.  I have accounts with these platforms:
</p>

<section>
<!-- TODO add PayPal, BuyMeACoffee, Patreon, etc... -->
</section>
